/*--------------  FrvBuf.h by B.Mours Jul 07, 2004--------------------------*/

#ifndef FRVCH
#define FRVCH

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif

#include "Frv.h"

#ifdef __cplusplus
extern "C" {
#endif

struct FrvCh {        /* This is the FrVect Buffering object           */
  char *name;         /* vector or SerData name                        */
  char *smsParam;     /* serData parameter name (if isSerData=YES)     */
  double duration;    /* requested length for the vector output        */
  double stillToFeed; /* length of the missing data segement           */
  double lastGPS;     /* end time of the last input data segement      */
  int    dt;          /* period for finding the data in a frame        */
  FRBOOL init;        /* tell if the channel type has been determined  */
  FRBOOL isSerData;   /* tell if it is a SerData                       */
  FrvBuf *buffer;     /* buffer used for vector if not a SerData       */
  FrVect *output;     /* output vector                                 */
};

typedef struct FrvCh FrvCh;

void    FrvChFree    (FrvCh* frCh);
double  FrvChFeed    (FrvCh *frCh, FrameH *frame);
FrVect* FrvChGetVect (FrvCh* frCh);
FrvCh*  FrvChNew     (char *channelName, double duration);

#ifdef __cplusplus
}
#endif

#endif
